#include "graphwnd.h"

#include <time.h>

CGraphWnd::CGraphWnd(
  ISysMonWnd* pParent,
  unsigned int index,
  bool_t bVisible)
{
  m_pParent = pParent;
  m_pToolbar = NULL;
  m_pScope = NULL;
  m_index = index;

  m_pToolbar = getFactory().createGraphWndToolbar(this, m_index);
  m_vBoxCtl.pack_start(m_pToolbar->getNativeControl(), FALSE, FALSE);
  m_pScope = getFactory().createScopeWnd(this);
  m_vBoxCtl.pack_start(m_pScope->getNativeControl(), TRUE, TRUE);
  add(m_vBoxCtl);
}

CGraphWnd::~CGraphWnd()
{
  if (NULL != m_pToolbar) {
    delete m_pToolbar;
    m_pToolbar = NULL;
  }
  if (NULL != m_pScope) {
    delete m_pScope;
    m_pScope = NULL;
  }
}

void
CGraphWnd::deviceChanged()
{
  m_pScope->deviceChanged();
  m_pToolbar->deviceChanged();
}

void
CGraphWnd::update(timestamp_t timestamp)
{
  if (!m_pToolbar->getPaused()) {
    m_currentTimestamp = timestamp - m_startTimestamp;
    m_pScope->update(m_currentTimestamp);
  }
}

void
CGraphWnd::setIndex(
  unsigned int index)
{
  m_index = index;
  m_pToolbar->setIndex(index);
}

void
CGraphWnd::started()
{
  m_startTimestamp = getTimeNow();
  m_currentTimestamp = TIMESTAMP_INVALID;
}

void
CGraphWnd::viewChanged(
  timestamp_t interval,
  timestamp_t minShow,
  timestamp_t maxShow)
{
  /* Nothing here yet */
}
